//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////
#include "scene.h"
//////////////////////////////////////////////////////////////////////

// Tu je vsetko co sa kresli
void scene::DrawGLScene()
{
	vec4 lp[17];
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	c->MoveWorld(fps, ROTATE_WALK|ROTATE_ABOUT_POINT);	// otoci svetom na zaklade vstupov od mysi a klavesnice
	c->SetTransform();
	if(keys['L'] && keys[VK_CONTROL]){ english = !english; keys['L']=0; }
	if(keys['P'])glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	else	 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glDisable(GL_TEXTURE_2D);
	glEnable(GL_LIGHTING);

	static int stage=3;
	static int model=1;
	static int stop=0;

	if(keys['1'])stage=1;
	else if(keys['2'])stage=2;
	else if(keys['3'])stage=3;
	if(keys[VK_SPACE]){	model=!model;keys[VK_SPACE]=0;}
	if(keys['B']){	stop=!stop;keys['B']=0;}

	static float rotz=0.f;
	static float roty=0.f;
	if(keys['R'])
	{
		rotz=0;
		roty=0;
	}
	if(!stop)
	{
		rotz+=90.f*timeframe;
		roty+=10.f*timeframe;
	}

	if(stage==1 || stage==2)		// 8 lights
	{
		vec a;
		for(int i=0; i<8; i++)
		{
			if(i<4)
			{
				a.set(2.0f,0,0);
				a.RotZ(rotz+(float)i*360.f/(float)4.f);
				a.y *= 0.5;
				a.RotZ(45.f);
				a.RotY(roty);
			}
			else
			{
				a.set(2.0f,0,0);
				a.RotZ(rotz+(float)i*360.f/(float)4.f+45.f);
				a.y *= 0.5f;
				a.RotZ(-45.f);
				a.RotY(roty+90.f);
			}
			lp[i] = a;

			if(stage == 1)
			{
				glLightfv ( GL_LIGHT0 + i, GL_DIFFUSE, color[i].v );			// nastavenie difuzneho svetla
				glLightfv ( GL_LIGHT0 + i, GL_POSITION, lp[i].v );		// pozicia difuzneho svetla
				glEnable  ( GL_LIGHT0 + i );
			}
		}
	}
	else		// 17 lights
	{
		vec a;
		for(int i=0; i<17; i++)
		{
			if(i<8)
			{
				a.set(2.0f,0,0);
				a.RotZ(rotz+(float)i*360.f/(float)8.f);
				a.y *= 0.5f;
				a.RotZ(45.f);
				a.RotY(roty);
			}
			else
			{
				a.set(2.0f,0,0);
				a.RotZ(rotz+(float)i*360.f/(float)9.f+45.f);
				a.y *= 0.5f;
				a.RotZ(-45.f);
				a.RotY(roty+90.f);
			}
			lp[i] = a;
		}
	}

	mat4 proj,mod,m;
	mod.glGetMatrix();

	if(stage==2 || stage==3)
	{
	//	glGetFloatv( GL_PROJECTION_MATRIX, proj.m);
	//	m = proj*mod;
	//	m = ~m;
	//	glProgramLocalParameter4fvARB( GL_VERTEX_PROGRAM_ARB, 0, &m.m11 );
	//	glProgramLocalParameter4fvARB( GL_VERTEX_PROGRAM_ARB, 1, &m.m12 );
	//	glProgramLocalParameter4fvARB( GL_VERTEX_PROGRAM_ARB, 2, &m.m13 );
	//	glProgramLocalParameter4fvARB( GL_VERTEX_PROGRAM_ARB, 3, &m.m14 );

		for(int i=0; i<17; i++)
		{
			glProgramLocalParameter4fvARB( GL_VERTEX_PROGRAM_ARB, i+10, lp[i].v );
			glProgramLocalParameter4fvARB( GL_VERTEX_PROGRAM_ARB, i+40, color[i].v );
		}
	}

	if(stage==2)
	{
		glBindProgramARB(GL_VERTEX_PROGRAM_ARB, hVertexShader8);
		glEnable(GL_VERTEX_PROGRAM_ARB);
	}
	else if(stage==3)
	{
		glBindProgramARB(GL_VERTEX_PROGRAM_ARB, hVertexShader17);
		glEnable(GL_VERTEX_PROGRAM_ARB);
	}

	if(model==0)
		sphere.Render();
	else
		obj->Render(0,0);
	
	if(stage==2 || stage==3) glDisable(GL_VERTEX_PROGRAM_ARB);

	for(int i=0; i<8; i++) glDisable  ( GL_LIGHT0 + i );
	glDisable(GL_LIGHTING);
	
	int count_of_light = (stage==1 || stage==2) ? 8:17;
	for( i=0; i<count_of_light; i++)
	{
		m = mod;
		m.Translate(lp[i]);
		m.glSetMatrix();
		glColor3fv( color[i].v);
		spherelight.Render();
	}

	glEnable(GL_TEXTURE_2D);
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	glColor3f(1,1,1);

//	glTranslatef(0,1,0); Paint_axes();
/*	this->Print_vec( 0, 1, c->vp, "vp");
	this->Print_vec( 0, 2, c->vr, "vr");
	this->Print_vec( 0, 3, c->vu, "vu");
	this->Print_vec( 0, 4, c->vd, "vd");
*/
	glColor4f(1,1,1,1);
	
	// vypis FPS
	glEnable( GL_TEXTURE_2D);
	font0->Begin();
	timeframe = timer0.GetTime();
	fps = 1.0f / timeframe;
	timer0.Reset();
	fps_counter.GetAvgFps(timeframe,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);

	if(keys[VK_F12]){	SaveScreen_BMP(); keys[VK_F12] = 0;}

	switch(stage)
	{
	case 1:
		font0->Print(1,1,"8 point lights, fixed function pipeline", 0);
		break;
	case 2:
		font0->Print(1,1,"8 point lights, ARB vertex program", 0);
		break;
	default:
		font0->Print(0,1,"17 point lights, ARB vertex program", 0);
	}

	if(keys['H'])							// zobrazenie helpu
	{
		int i=3;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.4f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(40,210);
			glVertex2i(800-60,210);
			glVertex2i(800-60,600-48);
			glVertex2i(40,600-48);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);

		if(english)
		{
			font0->Print(10,i++,"Program: Many Point Lights - ARB vertex program", 0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(15,i++,"Controls:", 1);
			font0->Print(20,i++,"1,2,3 - change count of lights", 1);
			font0->Print(20,i++,"space - change model", 1);
			font0->Print(20,i++,"B - on/off rotation of lights", 1);
			font0->Print(20,i++,"P - wire frame", 1);
			font0->Print(20,i++,"R - reset light positions", 1);
			i++;
			font0->Print(20,i++,"F12 - take screenshot",1);
			font0->Print(20,i++,"F4 - toggle fullscreen", 1);
			font0->Print(20,i++,"H - help", 1);
			i++;
			font0->Print(2,i++,"Controls of camera:",0);
			font0->Print_scale(2,i++,"W,S,arrow up,down,left and right button - move forward and backward",1,0.94f,1);
			font0->Print(2,i++,"A,D,Delete,Insert - move left and right",1);
			font0->Print(2,i++,"Home,End - move up and down",1);
			font0->Print(2,i++,"arrow right,left and moving mouse <-> - rotation about y axis",1);
			font0->Print(2,i++,"Page Up, Page Down a moving mouse | - rotation about x axis",1);
			font0->Print(2,i++,"Shift - slow moving",1);
			font0->Print(2,i++,"R - reset camera",1);
		}
		else
		{
			font0->Print(10,i++,"Program: Many Point Lights - ARB vertex program", 0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(15,i++,"Pouzivane klavesy:", 1);
			font0->Print(20,i++,"1,2,3 - meni pocet svetiel", 1);
			font0->Print(20,i++,"medzernik - meni meni model", 1);
			font0->Print(20,i++,"B - zastavy/spusti rotaciu svetiel", 1);
			font0->Print(20,i++,"P - zapne ciarovy rezim", 1);
			font0->Print(20,i++,"R - reset pozicie svetiel", 1);
			i++;
			font0->Print(20,i++,"F12 - ulozi obrazovku do subora",1);
			font0->Print(20,i++,"F4 - prepina do/z fullscreen", 1);
			font0->Print(20,i++,"H - help", 1);
			i++;
			font0->Print(4,i++,"Ovladanie kamery:",0);
			font0->Print_scale(4,i++,"W,S,sipka hore,dole,lave a prave tlacitko - pohyb dopredu a dozadu",1,0.94f,1);
			font0->Print(4,i++,"A,D,Delete,Insert - pohyb do boka vlavo vpravo",1);
			font0->Print(4,i++,"Home,End - pohyb hore, dole",1);
			font0->Print(4,i++,"sipka vpravo,vlavo a pohyb mysov <->  - rotacia okolo osi y",1);
			font0->Print(4,i++,"Page Up, Page Down a pohyb mysov | - rotacia okolo osi x",1);
			font0->Print(4,i++,"Shift - pomalsi pohyb",1);
			font0->Print(4,i++,"R - reset kamery",1);
		}
	}
	font0->End();
}
