// Sphere.cpp: implementation of the Sphere class.
//
//////////////////////////////////////////////////////////////////////

#include "Sphere.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Sphere::Sphere()
{
	display_list_id=0;
}

Sphere::~Sphere()
{
	if(display_list_id!=0)glDeleteLists( display_list_id, 1);
}

void Sphere::Render()
{
	glCallList(display_list_id);
}

int Sphere::Init( int del_uhol_x, int del_uhol_y, float size)
{
	display_list_id = glGenLists(1);
	glNewList( display_list_id, GL_COMPILE);
	DrawSphereBase( del_uhol_x, del_uhol_y, size);
	glEndList();
	return 1;
}

void Sphere::DrawSphereBase(int del_uhol_x, int del_uhol_y, float size)
{
	// del_uhol_x krat 2*(del_uhol_y+1) bodov
	vec a,b,ay,by;
	float dy=360.f/del_uhol_y;
	float dx=180.f*PI180/del_uhol_x;
	for(int x=0; x<del_uhol_x; x++)
	{
		float tx = (float)x/(float)del_uhol_x;
		float ang = tx*180.f*PI180-90.f*PI180;
		a.set( 0, (float)sin(ang) , (float)cos(ang));
		b.set( 0, (float)sin(ang+dx), (float)cos(ang+dx));
		
		glBegin( GL_TRIANGLE_STRIP);

		glTexCoord2f( 0, tx);
		glNormal3fv(a.v);
		glVertex3fv((size*a).v);
		glTexCoord2f( 0, tx+1.f/del_uhol_x);
		glNormal3fv(b.v);
		glVertex3fv((size*b).v);

		ay = a;	by = b;
		for(int y=1; y<del_uhol_y+1; y++)
		{
			float ty = (float)y/(float)del_uhol_y;
			ay = a;	ay.RotY( ty*360.f);
			by = b;	by.RotY( ty*360.f);
			glTexCoord2f( ty, tx);
			glNormal3fv(ay.v);
			glVertex3fv((size*ay).v);
			glTexCoord2f( ty, tx+1.f/del_uhol_x);
			glNormal3fv(by.v);
			glVertex3fv((size*by).v);
		}
		glEnd();
	}
}
